module Counter #(
	parameter WIDTH = 4   // Liczba bitw licznika
)(
	input Clock,          // Zegar
	input Reset,          // 1 - praca, 0 - reset
	input CountUp,        // 1 - zezwolenie na liczenie w gr
	input CountDown,      // 1 - zezwolenie na liczenie w d
	output reg [WIDTH-1:0] Value   // Warto licznika
);
	
	always @(posedge Clock, negedge Reset) begin
		if(!Reset)
			Value <= 0;
		else if(CountUp)
			Value <= Value + 1'b1;      // 1
		else if(CountDown)
			Value <= Value - 1'b1;	     // 2
	end

endmodule
