module Debounce(
	input      Clock,
	input      Reset,
	input      NoisySignal,
	output reg FilteredSignal
);
	
	reg State = 1'b0;
	reg [17:0] Counter = 0;
	
	parameter MAX = 140000;
	
	always @(posedge Clock, negedge Reset) begin
		if(!Reset) begin
			Counter <= 18'd0;
			State   <= 1'b0;
		end else if(NoisySignal != FilteredSignal && Counter < MAX) begin
			Counter <= Counter + 1'b1;
		end else if(Counter == MAX) begin
			Counter <= 18'd0;
			FilteredSignal <= NoisySignal;
		end else begin
			Counter <= 18'd0;
		end
			
	end
	
endmodule
