module Decoder7seg #(
	parameter COMMON_CATHODE = 1  // 1 - wsplna katoda, 0 - anoda
)(
	input  [3:0] Data,           // 4-bitowa liczba
	output [6:0] Segments        // Do wywietlacza
);
	
	reg    [6:0] Temp;           // Zmienna robocza
	
	always @(*) begin
		case(Data)
			// Opis segmentw   gfedcba
			4'h0:    Temp = 7'b0111111;
			4'h1:    Temp = 7'b0000110;
			4'h2:    Temp = 7'b1011011;
			4'h3:    Temp = 7'b1001111;
			4'h4:    Temp = 7'b1100110;
			4'h5:    Temp = 7'b1101101;
			4'h6:    Temp = 7'b1111101;
			4'h7:    Temp = 7'b0000111;
			4'h8:    Temp = 7'b1111111;
			4'h9:    Temp = 7'b1101111;
			4'hA:    Temp = 7'b1110111;
			4'hB:    Temp = 7'b1111100;
			4'hC:    Temp = 7'b0111001;
			4'hD:    Temp = 7'b1011110;
			4'hE:    Temp = 7'b1111001;
			4'hF:    Temp = 7'b1110001;
//			default: Temp = 7'b0000000;
		endcase
	end
	
	// Obsuga wywietlaczy ze wspln katod lub anod
	assign Segments = COMMON_CATHODE ? Temp : ~Temp;
	
endmodule
