module EdgeDetector(
  input  Clock,       // Zegar
  input  Reset,       // 1 - praca, 0 - reset
  input  Signal,      // Badany sygna
  output RisingEdge,  // 1 - wykrycie zbocza rosncego
  output FallingEdge  // 1 - wykrycie zbocza malejcego
);

  reg Previous = 0;                                               // 1
  
  always @(posedge Clock, negedge Reset)
    if(!Reset)
      Previous <= 0;
  	else
      Previous <= Signal;                                         // 2
  
  assign RisingEdge  = (Previous == 1'b0) && (Signal == 1'b1);  // 3
  assign FallingEdge = (Previous == 1'b1) && (Signal == 1'b0);  // 4
  
endmodule
